package com.lideeyunji.service.system.api;

import com.lideeyunji.tool.framework.common.util.object.BeanUtils;
import com.lideeyunji.service.system.dto.OAuth2AccessTokenCheckRespDTO;
import com.lideeyunji.service.system.dto.OAuth2AccessTokenCreateReqDTO;
import com.lideeyunji.service.system.dto.OAuth2AccessTokenRespDTO;
import com.lideeyunji.service.system.entity.OAuth2AccessTokenDO;
import com.lideeyunji.service.system.service.IOAuth2TokenService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * OAuth2.0 Token API 实现类
 *
 * @author 金灯剑客
 */
@Service
public class ApiOAuth2TokenApiImpl implements IApiOAuth2TokenApi {

    @Resource
    private IOAuth2TokenService oauth2TokenService;

    @Override
    public OAuth2AccessTokenRespDTO createAccessToken(OAuth2AccessTokenCreateReqDTO reqDTO) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.createAccessToken(
                reqDTO.getUserId(),reqDTO.getLoginDeptId(),reqDTO.getLoginRoleId(), reqDTO.getUserType(), reqDTO.getClientId(), reqDTO.getScopes());
        return BeanUtils.toBean(accessTokenDO, OAuth2AccessTokenRespDTO.class);
    }

    @Override
    public OAuth2AccessTokenCheckRespDTO checkAccessToken(String accessToken) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.checkAccessToken(accessToken);
        return BeanUtils.toBean(accessTokenDO, OAuth2AccessTokenCheckRespDTO.class);
    }

    @Override
    public OAuth2AccessTokenRespDTO removeAccessToken(String accessToken) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.removeAccessToken(accessToken);
        return BeanUtils.toBean(accessTokenDO, OAuth2AccessTokenRespDTO.class);
    }

    @Override
    public OAuth2AccessTokenRespDTO refreshAccessToken(String refreshToken, String clientId) {
        OAuth2AccessTokenDO accessTokenDO = oauth2TokenService.refreshAccessToken(refreshToken, clientId);
        return BeanUtils.toBean(accessTokenDO, OAuth2AccessTokenRespDTO.class);
    }

}
